-- name: [CS] Weirdo
-- description: Weirdo.

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
	(This is an edited version of the Template File by Squishy)
]]

local TEXT_MOD_NAME = "Weirdo"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_CUSTOM_MODEL = smlua_model_util_get_id("weirdo_geo") -- Located in "actors"

local TEX_CUSTOM_LIFE_ICON = get_texture_info("weirdolife") -- Located in "textures"

-- All Located in "sound" Name them whatever you want. Remember to include the .ogg extension
local VOICETABLE_WEIRDO = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Silent.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Silent.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Swipe.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Swipe.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Swipe2.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Silent.ogg', 'Silent.ogg', 'Silent.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Silent.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Silent.ogg', 'Silent.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Silent.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Silent.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Silent.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Silent.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Silent.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Silent.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Silent.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Silent.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Silent.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Silent.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Silent.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Silent.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Silent.ogg' -- Booted out of level
}

-- All Located in "actors"
local CAPTABLE_WEIRDO = {
    normal = smlua_model_util_get_id("weirdonormal_geo"),
    wing = smlua_model_util_get_id("weirdowing_geo"),
    metal = smlua_model_util_get_id("weirdometal_geo"),
}

local PALETTE_CHAR = {
    [PANTS]  = "49100A",
    [SHIRT]  = "FFD2FF",
    [GLOVES] = "ffffff",
    [SHOES]  = "270602",
    [HAIR]   = "691022",
    [SKIN]   = "FF836C",
    [CAP]    = "382074",
	[EMBLEM] = "691022"
}

local HM_WEIRDO= {
    label = {
        left = get_texture_info("Weirdo_Left_Part"),
        right = get_texture_info("Weirdo_Right_Part"),
    },
    pie = {
        [1] = get_texture_info("Weirdo_Slice_1"),
        [2] = get_texture_info("Weirdo_Slice_2"),
        [3] = get_texture_info("Weirdo_Slice_3"),
        [4] = get_texture_info("Weirdo_Slice_4"),
        [5] = get_texture_info("Weirdo_Slice_5"),
        [6] = get_texture_info("Weirdo_Slice_6"),
        [7] = get_texture_info("Weirdo_Slice_7"),
        [8] = get_texture_info("Weirdo_Slice_8"),
    }
}

local CSloaded = false
local function on_character_select_load()
    CT_SWEIRDO = _G.charSelect.character_add("Weirdo", {"From the unreleased 'Ultra 64'", "title WEIRDO'S WORLD, comes Weirdo!", "A veritable mess of a", "self-insert-", "turned-fake-video-game-protaganist!", "Guide her, or they, whatever it is today,", "through many perilous platforming problems!", "Listen to music that is older than you!", "Become one with your mistakes.", "Be Weirdo."}, "Pinkerton by Weezer", {r = 255, g = 255, b = 255}, E_MODEL_CUSTOM_MODEL, CT_WEIRDO, TEX_CUSTOM_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MODEL_CUSTOM_MODEL, CAPTABLE_WEIRDO)
    _G.charSelect.character_add_voice(E_MODEL_CUSTOM_MODEL, VOICETABLE_WEIRDO)
    _G.charSelect.character_add_celebration_star(E_MODEL_CUSTOM_MODEL, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_CUSTOM_MODEL, PALETTE_CHAR)
    _G.charSelect.character_add_health_meter(CT_SWEIRDO, HM_WEIRDO)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_WEIRDO then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_WEIRDO then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)